using UnityEngine;
using UnityEngine.UI;
using System;
using System.Collections.Generic;

namespace FrogFrog
{
    public class MLSCC : MVRScript
    {
        //UI Elements For Public
        private JSONStorableString jsNavBar = new JSONStorableString("NavBar", "");
        private JSONStorableString jsDesc = new JSONStorableString("Desc", "");
        private UIDynamicButton uiReturn;
        private UIDynamicButton uiReFlesh;
        private UIDynamicButton uiSave;
        private UIDynamicButton uiTestAGroup;
        private UIDynamicButton uiRefleshPlugins;
        private UIDynamicTextField uiNavBar;
        private UIDynamicTextField uiDesc;
        private UIDynamicButton uiSwitchInfo;

        //UI Elements For Action Groups Section
        private JSONStorableStringChooser jsAGroups = new JSONStorableStringChooser("AGroups", new List<string>(), "", "Action Groups");
        private JSONStorableString jsAGComment = new JSONStorableString("AGComment", "");
        private UIDynamicButton uiAGAdd;
        private UIDynamicButton uiAGRemove;
        private UIDynamicButton uiAGDuplicate;
        private UIDynamicButton uiSetActions;
        private UIDynamicPopup uiAGroups;
        private UIDynamicLabelInput uiAGComment;

        //UI Elements For Actions Section
        private JSONStorableStringChooser jsActions = new JSONStorableStringChooser("Actions", new List<string>(), "", "Actions");
        private JSONStorableString jsAComment = new JSONStorableString("AComment", "");
        private JSONStorableString jsTargetGPs = new JSONStorableString("Target GPs", "");
        private JSONStorableString jsTargetLgts = new JSONStorableString("Target Ltgs", "");
        private JSONStorableBool jsUseCP = new JSONStorableBool("Use Color Picker", true);
        private UIDynamicButton uiAAdd;
        private UIDynamicButton uiARemove;
        private UIDynamicButton uiADuplicate;
        private UIDynamicButton uiSetGPMotions;
        private UIDynamicButton uiSetLPMotions;
        private UIDynamicPopup uiActions;
        private UIDynamicLabelInput uiAComment;
        private UIDynamicLabelInput uiTargetGPs;
        private UIDynamicLabelInput uiTargetLgts;
        private UIDynamicToggle uiUseCP;
        private UIDynamicTextInfo uiGroupInfo;
        private UIDynamicTextInfo uiLightInfo;

        //UI Elements For Property Motions Section
        private JSONStorableStringChooser jsProperties = new JSONStorableStringChooser("Properties", new List<string>(), "", "Motion Properties");
        private JSONStorableBool jsIsActive = new JSONStorableBool("Is Active", false);
        private JSONStorableBool jsLoopPlay = new JSONStorableBool("Loop Play", false);
        private JSONStorableStringChooser jsMotionType = new JSONStorableStringChooser("MotionType", GlobalConst.MotionTypeList, "", "Motion Type");
        private JSONStorableString jsRefValue = new JSONStorableString("Refer To", "");
        private JSONStorableStringChooser jsWaitFor = new JSONStorableStringChooser("WaitFor", GlobalConst.ValueTypeList, "", "Waiting Value Type");
        private JSONStorableFloat jsWaitForVal1 = new JSONStorableFloat("Waiting Time (s)", 0.0F, 0.0F, 100.0f);
        private JSONStorableFloat jsWaitForVal2 = new JSONStorableFloat("Alt Waiting Time (s)", 0.0F, 0.0F, 100.0f);
        private JSONStorableStringChooser jsWarmUp = new JSONStorableStringChooser("WarmUp", GlobalConst.ValueTypeList, "", "Warm Up Value Type");
        private JSONStorableFloat jsWarmUpVal1 = new JSONStorableFloat("Warm Up Time (s)", 0.0F, 0.0F, 100.0f);
        private JSONStorableFloat jsWarmUpVal2 = new JSONStorableFloat("Alt Warm Up Time (s)", 0.0F, 0.0F, 100.0f);
        private JSONStorableStringChooser jsCoolDown = new JSONStorableStringChooser("CoolDown", GlobalConst.ValueTypeList, "", "Cool Down Value Type");
        private JSONStorableFloat jsCoolDownVal1 = new JSONStorableFloat("Cool Down Time (s)", 0.0F, 0.0F, 100.0f);
        private JSONStorableFloat jsCoolDownVal2 = new JSONStorableFloat("Alt Cool Down Time (s)", 0.0F, 0.0F, 100.0f);
        private UIDynamicPopup uiProperties;
        private UIDynamicToggle uiIsActive;
        private UIDynamicToggle uiLoopPlay;
        private UIDynamicPopup uiMotionType;
        private UIDynamicLabelInput uiRefValue;
        private UIDynamicPopup uiWaitFor;
        private UIDynamicSlider uiWaitForVal1;
        private UIDynamicSlider uiWaitForVal2;
        private UIDynamicPopup uiWarmUp;
        private UIDynamicSlider uiWarmUpVal1;
        private UIDynamicSlider uiWarmUpVal2;
        private UIDynamicPopup uiCoolDown;
        private UIDynamicSlider uiCoolDownVal1;
        private UIDynamicSlider uiCoolDownVal2;
        private UIDynamicButton uiSetMNodes;

        //UI Elements For Motion Nodes Section
        private JSONStorableStringChooser jsMotionNodes = new JSONStorableStringChooser("MotionNodes", new List<string>(), "", "Motion Nodes");
        private JSONStorableStringChooser jsSpeedMode = new JSONStorableStringChooser("SpeedMode", GlobalConst.SpeedModeList, "", "Speed Mode");
        private JSONStorableStringChooser jsTime = new JSONStorableStringChooser("Time", GlobalConst.ValueTypeList, "", "Time Value Type");
        private JSONStorableFloat jsTime1 = new JSONStorableFloat("Time Stamp", 0.0F, 0.0F, 100.0f);
        private JSONStorableFloat jsTime2 = new JSONStorableFloat("Alt Time Stamp", 0.0F, 0.0F, 100.0f);
        private JSONStorableStringChooser jsValue = new JSONStorableStringChooser("Value", GlobalConst.ValueTypeList, "", "Target Value Type");
        private JSONStorableFloat jsValue1 = new JSONStorableFloat("Target Value", 0.0F, 0.0F, 100.0f);
        private JSONStorableFloat jsValue2 = new JSONStorableFloat("Alt Target Value", 0.0F, 0.0F, 100.0f);
        private JSONStorableColor jsColor1 = new JSONStorableColor("Target Value (Color)", new HSVColor { H = 0.0F, S = 0.0F, V = 0.0F });
        private JSONStorableColor jsColor2 = new JSONStorableColor("Alt Target Value (Color)", new HSVColor { H = 0.0F, S = 0.0F, V = 0.0F });
        private JSONStorableBool jsSetTrigger = new JSONStorableBool("Set Trigger", false);
        private JSONStorableBool jsIsRepeatable = new JSONStorableBool("Is Repeatable", false);
        private JSONStorableString jsTraceAtom = new JSONStorableString("Trace Atom", "");
        private JSONStorableFloat jsThreshold = new JSONStorableFloat("Threshold", 1.0f, 1.0f, 100.0f);
        private JSONStorableBool jsIsInternal = new JSONStorableBool("Is Internal", false);
        private JSONStorableString jsDoAction = new JSONStorableString("Do Action", "");
        private UIDynamicPopup uiMotionNodes;
        private UIDynamicPopup uiSpeedMode;
        private UIDynamicButton uiNodeAdd;
        private UIDynamicButton uiNodeRemove;
        private UIDynamicPopup uiTime;
        private UIDynamicSlider uiTime1;
        private UIDynamicSlider uiTime2;
        private UIDynamicPopup uiValue;
        private UIDynamicSlider uiValue1;
        private UIDynamicSlider uiValue2;
        private UIDynamicColorPicker uiColor1;
        private UIDynamicColorPicker uiColor2;
        private UIDynamicToggle uiSetTrigger;
        private UIDynamicToggle uiIsRepeatable;
        private UIDynamicLabelInput uiTraceAtom;
        private UIDynamicSlider uiThreshold;
        private UIDynamicToggle uiIsInternal;
        private UIDynamicLabelInput uiDoAction;

        //Build MLS Config Object
        private JSONStorableString jsMLSConfStr = new JSONStorableString("MLS Config", "");
        private JSONStorableString jsAGroupName = new JSONStorableString("AGroup Name", "");
        private JSONStorableAction jsPerformAGroup;
        private ConfMain MLSConfObj = new ConfMain();
        private MLSMotion MLSMotionObj = new MLSMotion();
        private float modifiedTime = 0.0F;
        private float savedTime = 0.0F;
        private Dictionary<string, NavInfoStru> NavInfo = new Dictionary<string, NavInfoStru>();
        private bool showStructure = false;

        public override void Init()
        {
            RegisterString(jsMLSConfStr);
            RegisterString(jsAGroupName);
            jsPerformAGroup = new JSONStorableAction("Perform The AGroup", PerformAGroup);
            RegisterAction(jsPerformAGroup);

            Utils.InitUI(CreateUIElement);
            GlobalConst.InitDic();
            BasicUIInit();
            AGroupInit();
            ActionInit();
            PropertyInit();
            MNodeInit();
            AGroupShow();
        }
        public void BasicUIInit()
        {
            uiReturn = CreateButton("<<< Return");
            uiReturn.button.onClick.AddListener(ReturnToParent);
            uiReturn.buttonColor = Color.green;
            uiReturn.button.interactable = false;

            uiNavBar = CreateTextField(jsNavBar);
            jsNavBar.val = $"{GlobalConst.NavBass}";
            uiNavBar.height = 100;
            uiNavBar.backgroundColor = Color.black;
            uiNavBar.textColor = Color.cyan;

            uiReFlesh = CreateButton("Reflesh Groups and Lights", true);
            uiReFlesh.buttonColor = Color.gray;
            uiReFlesh.textColor = Color.white;
            uiReFlesh.button.onClick.AddListener(RefleshAtoms);

            uiRefleshPlugins = CreateButton("Reflesh Relative Plugins", true);
            uiRefleshPlugins.buttonColor = Color.gray;
            uiRefleshPlugins.textColor = Color.white;
            uiRefleshPlugins.button.onClick.AddListener(RefleshPlugins);
            //uiRefleshPlugins.button.interactable = false;

            uiSave = CreateButton("Manually Save", true);
            uiSave.buttonColor = Color.gray;
            uiSave.textColor = Color.white;
            uiSave.button.onClick.AddListener(SaveMLSConf);

            uiTestAGroup = CreateButton("Test Current Action Group", true);
            uiTestAGroup.buttonColor = Color.gray;
            uiTestAGroup.textColor = Color.white;
            uiTestAGroup.button.onClick.AddListener(TryAGroup);

            uiDesc = CreateTextField(jsDesc, true);
            uiDesc.height = 870;

            uiSwitchInfo = CreateButton("Switch TO Configuration Structure", true);
            uiSwitchInfo.buttonColor = Color.green;
            uiSwitchInfo.button.onClick.AddListener(SwitchInfo);
        }
        private void SwitchInfo()
        {
            if (showStructure)
            {
                jsDesc.val = GetDescription();
                showStructure = false;
                uiSwitchInfo.label = "Switch TO Configuration Structure";
            }
            else
            {
                jsDesc.val = GetConfStructure();
                showStructure = true;
                uiSwitchInfo.label = "Switch To Description";
            }
        }
        private void RefleshInfo()
        {
            if (showStructure) jsDesc.val = GetConfStructure();
            else jsDesc.val = GetDescription();
        }
        private void LoadMLSConf() { MLSConfObj.ParseStrToConf(jsMLSConfStr.val); AGroupGetVal(); }
        private void SaveMLSConf()
        {
            if (savedTime < modifiedTime)
            {
                jsMLSConfStr.val = MLSConfObj.ParseConfToStr();
                savedTime = Time.time;
                //SuperController.LogMessage($"{savedTime} :: {jsMLSConfStr.val}");
            }
        }

        private void ReturnToParent()
        {
            NavInfoStru thisInfo;
            if (NavInfo.ContainsKey("Property"))
            {
                thisInfo = NavInfo["Property"];
                NavInfo.Remove("Property");
                MNodeHide();
                PropertyShow(thisInfo.label, thisInfo.index);
            }
            else if (NavInfo.ContainsKey("Action"))
            {
                thisInfo = NavInfo["Action"];
                NavInfo.Remove("Action");
                PropertyHide();
                ActionShow(thisInfo.label, thisInfo.index);
            }
            else if (NavInfo.ContainsKey("AGroup"))
            {
                thisInfo = NavInfo["AGroup"];
                NavInfo.Remove("AGroup");
                ActionHide();
                AGroupShow(thisInfo.label, thisInfo.index);
            }
            RefleshNavBar();
        }
        private void RefleshNavBar()
        {
            jsNavBar.val = GlobalConst.NavBass;
            if (NavInfo.ContainsKey("AGroup")) jsNavBar.val += NavInfo["AGroup"].label + GlobalConst.NavSeparator;
            if (NavInfo.ContainsKey("Action")) jsNavBar.val += NavInfo["Action"].label + GlobalConst.NavSeparator;
            if (NavInfo.ContainsKey("Property")) jsNavBar.val += NavInfo["Property"].label + GlobalConst.NavSeparator;
            if (jsNavBar.val != GlobalConst.NavBass)
            {
                uiReturn.button.interactable = true;
                //uiTestAction.button.interactable = true;
            }
            else
            {
                uiReturn.button.interactable = false;
                //uiTestAction.button.interactable = false;
            }
            SaveMLSConf();
        }
        private void RefleshAtoms() { MLSMotionObj.RefleshMLSAtoms(); }
        private void TryAction()
        {
            int AGi = NavInfo["AGroup"].index;
            int Aci = -1;
            if (NavInfo.ContainsKey("Action")) Aci = NavInfo["Action"].index;
            else Aci = jsActions.choices.FindIndex(x => x == jsActions.val);
            if (Aci < 0) return;
            MLSMotionObj.LoadAction(MLSConfObj.AGroups[AGi].Actions[Aci]);
        }
        private void TryAGroup()
        {
            int AGi = -1;
            if (NavInfo.ContainsKey("AGroup")) AGi = NavInfo["AGroup"].index;
            else AGi = jsAGroups.choices.FindIndex(x => x == jsAGroups.val);
            if (AGi < 0) return;
            MLSMotionObj.LoadAGroup(MLSConfObj.AGroups[AGi]);
        }
        private void PerformAGroup()
        {
            if (jsAGroupName.val != "")
            {
                foreach (var AGroup in MLSConfObj.AGroups)
                {
                    if (jsAGroupName.val == AGroup.name)
                    {
                        MLSMotionObj.LoadAGroup(AGroup);
                        return;
                    }
                }
            }
            SuperController.LogError("The AGroup Name can not be found!");
        }
        /////////////////////////////////
        //Action Groups UI Loghic Section
        /////////////////////////////////
        private void AGroupInit()
        {
            uiAGroups = CreateScrollablePopup(jsAGroups);
            jsAGroups.setCallbackFunction = (val) => { AGroupUpdate(); };

            uiAGAdd = CreateButton("Add Action Group");
            uiAGAdd.button.onClick.AddListener(AGroupAdd);

            uiAGDuplicate = CreateButton("Duplicate Action Group");
            uiAGDuplicate.button.onClick.AddListener(AGroupDup);

            uiAGRemove = CreateButton("Remove Action Group");
            uiAGRemove.buttonColor = Color.red;
            uiAGRemove.button.onClick.AddListener(AGroupRemove);
            uiAGRemove.button.interactable = false;

            uiAGComment = Utils.SetupTextInput(this, "Comment", jsAGComment, false);
            jsAGComment.setCallbackFunction = (val) => { jsAGComment.val = StringFormat(val); AGroupSetVal(); RefleshInfo(); };

            uiSetActions = CreateButton("Set Actions >>>");
            uiSetActions.button.onClick.AddListener(AGroupSetActions);
            uiSetActions.height = 100;
            uiSetActions.buttonColor = Color.green;

            AGroupHide();
        }
        private void AGroupShow(string label = "", int index = -1)
        {
            UIShowAndHide(uiAGroups, true);
            UIShowAndHide(uiAGAdd, true);
            UIShowAndHide(uiAGDuplicate, true);
            UIShowAndHide(uiAGRemove, true);
            UIShowAndHide(uiAGComment, true);
            UIShowAndHide(uiSetActions, true);
            AGroupGetVal(label, index);
        }
        private void AGroupHide()
        {
            UIShowAndHide(uiAGroups, false);
            UIShowAndHide(uiAGAdd, false);
            UIShowAndHide(uiAGDuplicate, false);
            UIShowAndHide(uiAGRemove, false);
            UIShowAndHide(uiAGComment, false);
            UIShowAndHide(uiSetActions, false);
        }
        private void AGroupGetVal(string label = "", int index = -1)
        {
            float tempTime = modifiedTime;
            List<string> AGroupNameList = new List<string>();
            foreach (var AGroup in MLSConfObj.AGroups) { AGroupNameList.Add(AGroup.name); }
            jsAGroups.choices = AGroupNameList;
            jsAGroups.displayChoices = AGroupNameList;

            if (jsAGroups.choices.Count > 0)
            {
                if (index < 0 || index >= jsAGroups.choices.Count) index = 0;
                jsAGroups.val = jsAGroups.choices[index];
            }
            else jsAGroups.val = "";

            if (index >= 0) jsAGComment.val = MLSConfObj.AGroups[index].comment;
            else jsAGComment.val = "";
            AGroupUIDLogic();
            modifiedTime = tempTime;
        }
        private void AGroupUpdate()
        {
            float tempTime = modifiedTime;
            int TMPi = jsAGroups.choices.FindIndex(x => x == jsAGroups.val);
            if (TMPi >= 0) jsAGComment.val = MLSConfObj.AGroups[TMPi].comment;
            AGroupUIDLogic();
            modifiedTime = tempTime;
        }
        private void AGroupSetVal()
        {
            int TMPi = jsAGroups.choices.FindIndex(x => x == jsAGroups.val);
            if (TMPi >= 0) { MLSConfObj.AGroups[TMPi].comment = jsAGComment.val; modifiedTime = Time.time; }
        }
        private void AGroupAdd()
        {
            NavInfoStru AGroupInfo = MLSConfObj.AddAGroup();
            AGroupGetVal(AGroupInfo.label, AGroupInfo.index);
            modifiedTime = Time.time;
        }
        private void AGroupDup()
        {
            int TMPi = jsAGroups.choices.FindIndex(x => x == jsAGroups.val);
            string copyStr = MLSConfObj.AGroups[TMPi].ParseConfToStr();
            NavInfoStru AGroupInfo = MLSConfObj.AddAGroup();
            MLSConfObj.AGroups[AGroupInfo.index].ParseStrToConf(copyStr);
            AGroupGetVal(AGroupInfo.label, AGroupInfo.index);
            modifiedTime = Time.time;
        }
        private void AGroupRemove()
        {
            NavInfoStru AGroupInfo = MLSConfObj.RemoveAGroup();
            AGroupGetVal(AGroupInfo.label, AGroupInfo.index);
            modifiedTime = Time.time;
        }
        private void AGroupSetActions()
        {
            int TMPi = jsAGroups.choices.FindIndex(x => x == jsAGroups.val);
            if (NavInfo.ContainsKey("AGroup")) NavInfo.Remove("AGroup");
            NavInfo.Add("AGroup", new NavInfoStru(jsAGroups.val, TMPi));
            RefleshNavBar();
            AGroupHide();
            ActionShow();
        }
        private void AGroupUIDLogic()
        {
            if (jsAGroups.choices.Count > 0 && jsAGroups.val == jsAGroups.choices[jsAGroups.choices.Count - 1]) { uiAGRemove.button.interactable = true; }
            else { uiAGRemove.button.interactable = false; }
            if (jsAGroups.val == "")
            {
                uiAGDuplicate.button.interactable = false;
                uiSetActions.button.interactable = false;
                uiAGComment.input.interactable = false;
            }
            else
            {
                uiAGDuplicate.button.interactable = true;
                uiSetActions.button.interactable = true;
                uiAGComment.input.interactable = true;
            }
            RefleshInfo();
        }

        /////////////////////////////////
        //Actions UI Loghic Section
        /////////////////////////////////
        private void ActionInit()
        {
            uiActions = CreateScrollablePopup(jsActions);
            jsActions.setCallbackFunction = (val) => { ActionUpdate(); };

            uiAAdd = CreateButton("Add Action");
            uiAAdd.button.onClick.AddListener(ActionAdd);

            uiADuplicate = CreateButton("Duplicate Action");
            uiADuplicate.button.onClick.AddListener(ActionDup);

            uiARemove = CreateButton("Remove Action");
            uiARemove.buttonColor = Color.red;
            uiARemove.button.onClick.AddListener(ActionRemove);
            uiARemove.button.interactable = false;

            uiAComment = Utils.SetupTextInput(this, "Comment", jsAComment, false);
            jsAComment.setCallbackFunction = (val) => { jsAComment.val = StringFormat(val); ActionSetVal("jsAComment"); RefleshInfo(); };

            uiTargetGPs = Utils.SetupTextInput(this, "Target GPs", jsTargetGPs, false);
            jsTargetGPs.setCallbackFunction = (val) => { jsTargetGPs.val = StringFormat(val); ActionSetVal("jsTargetGPs"); };

            uiGroupInfo = Utils.CreateInfoTextNoScroll(this, "<size=30>Light group <b>names</b> separated by \"<b>;</b>\". Use <b>All</b> or <b>AllRev</b> to control all.</size>", 110f, false);

            uiUseCP = CreateToggle(jsUseCP);
            jsUseCP.setCallbackFunction = (val) => { ActionSetVal("jsUseCP"); };

            uiSetGPMotions = CreateButton("Set Actions of Light Groups >>>");
            uiSetGPMotions.button.onClick.AddListener(ActionSetGPMotions);
            uiSetGPMotions.height = 100;
            uiSetGPMotions.buttonColor = Color.green;

            uiTargetLgts = Utils.SetupTextInput(this, "Target Lgts", jsTargetLgts, false);
            jsTargetLgts.setCallbackFunction = (val) => { jsTargetLgts.val = StringFormat(val); ActionSetVal("jsTargetLgts"); };

            uiLightInfo = Utils.CreateInfoTextNoScroll(this, "<size=30>Lights <b>Index</b> (zero-based) separated by \"<b>;</b>\". Use <b>All</b> or <b>AllRev</b> to control all.</size>", 110f, false);

            uiSetLPMotions = CreateButton("Set Actions of Lights >>>");
            uiSetLPMotions.button.onClick.AddListener(ActionSetLPMotions);
            uiSetLPMotions.height = 100;
            uiSetLPMotions.buttonColor = Color.green;
            ActionHide();
        }
        private void ActionShow(string label = "", int index = -1)
        {
            UIShowAndHide(uiActions, true);
            UIShowAndHide(uiAAdd, true);
            UIShowAndHide(uiADuplicate, true);
            UIShowAndHide(uiARemove, true);
            UIShowAndHide(uiAComment, true);
            UIShowAndHide(uiTargetGPs, true);
            UIShowAndHide(uiGroupInfo, true);
            UIShowAndHide(uiUseCP, true);
            UIShowAndHide(uiSetGPMotions, true);
            UIShowAndHide(uiTargetLgts, true);
            UIShowAndHide(uiLightInfo, true);
            UIShowAndHide(uiSetLPMotions, true);
            ActionGetVal(label, index);
        }
        private void ActionHide()
        {
            UIShowAndHide(uiActions, false);
            UIShowAndHide(uiAAdd, false);
            UIShowAndHide(uiADuplicate, false);
            UIShowAndHide(uiARemove, false);
            UIShowAndHide(uiAComment, false);
            UIShowAndHide(uiTargetGPs, false);
            UIShowAndHide(uiGroupInfo, false);
            UIShowAndHide(uiUseCP, false);
            UIShowAndHide(uiSetGPMotions, false);
            UIShowAndHide(uiTargetLgts, false);
            UIShowAndHide(uiLightInfo, false);
            UIShowAndHide(uiSetLPMotions, false);
        }
        private void ActionGetVal(string label = "", int index = -1)
        {
            float tempTime = modifiedTime;
            List<string> ActionNameList = new List<string>();
            int AGi = NavInfo["AGroup"].index;
            foreach (var Action in MLSConfObj.AGroups[AGi].Actions) { ActionNameList.Add(Action.name); }
            jsActions.choices = ActionNameList;
            jsActions.displayChoices = ActionNameList;

            if (jsActions.choices.Count > 0)
            {
                if (index < 0 || index >= jsActions.choices.Count) index = 0;
                jsActions.val = jsActions.choices[index];
            }
            else jsActions.val = "";

            if (index >= 0)
            {
                ConfActions thisAction = MLSConfObj.AGroups[AGi].Actions[index];
                jsAComment.val = thisAction.comment;
                jsTargetGPs.val = thisAction.targetGps;
                jsTargetLgts.val = thisAction.targetLgts;
                jsUseCP.val = thisAction.useCP;
            }
            else
            {
                jsAComment.val = "";
                jsTargetGPs.val = "";
                jsTargetLgts.val = "";
                jsUseCP.val = true;
            }
            ActionUIDLogic();
            modifiedTime = tempTime;
        }
        private void ActionUpdate()
        {
            float tempTime = modifiedTime;
            int TMPi = jsActions.choices.FindIndex(x => x == jsActions.val);
            int AGi = NavInfo["AGroup"].index;

            if (TMPi >= 0)
            {
                ConfActions thisAction = MLSConfObj.AGroups[AGi].Actions[TMPi];
                jsAComment.val = thisAction.comment;
                jsTargetGPs.val = thisAction.targetGps;
                jsTargetLgts.val = thisAction.targetLgts;
                jsUseCP.val = thisAction.useCP;
            }
            ActionUIDLogic();
            modifiedTime = tempTime;
        }
        private void ActionSetVal(string valName = "All")
        {
            int TMPi = jsActions.choices.FindIndex(x => x == jsActions.val);
            int AGi = NavInfo["AGroup"].index;
            if (TMPi >= 0)
            {
                ConfActions thisAction = MLSConfObj.AGroups[AGi].Actions[TMPi];
                if (valName == "All" || valName == "jsAComment") thisAction.comment = jsAComment.val;
                if (valName == "All" || valName == "jsTargetGPs") thisAction.targetGps = jsTargetGPs.val;
                if (valName == "All" || valName == "jsTargetLgts") thisAction.targetLgts = jsTargetLgts.val;
                if (valName == "All" || valName == "jsUseCP")
                {
                    if (thisAction.useCP != jsUseCP.val)
                    {
                        thisAction.GMPs[thisAction.GPMIndex["ColorH"]].MNodes.Clear();
                        thisAction.GMPs[thisAction.GPMIndex["ColorS"]].MNodes.Clear();
                        thisAction.GMPs[thisAction.GPMIndex["ColorV"]].MNodes.Clear();
                    }
                    thisAction.useCP = jsUseCP.val;
                }
                modifiedTime = Time.time;
            }
        }
        private void ActionAdd()
        {
            int AGi = NavInfo["AGroup"].index;
            NavInfoStru ActionInfo = MLSConfObj.AGroups[AGi].AddAction();
            ActionGetVal(ActionInfo.label, ActionInfo.index);
            modifiedTime = Time.time;
        }
        private void ActionDup()
        {
            int TMPi = jsActions.choices.FindIndex(x => x == jsActions.val);
            int AGi = NavInfo["AGroup"].index;
            string copyStr = MLSConfObj.AGroups[AGi].Actions[TMPi].ParseConfToStr();
            NavInfoStru ActionInfo = MLSConfObj.AGroups[AGi].AddAction();
            MLSConfObj.AGroups[AGi].Actions[ActionInfo.index].ParseStrToConf(copyStr);
            ActionGetVal(ActionInfo.label, ActionInfo.index);
            modifiedTime = Time.time;
        }
        private void ActionRemove()
        {
            int AGi = NavInfo["AGroup"].index;
            NavInfoStru ActionInfo = MLSConfObj.AGroups[AGi].RemoveAction();
            ActionGetVal(ActionInfo.label, ActionInfo.index);
            modifiedTime = Time.time;
        }
        private void ActionSetGPMotions()
        {
            int TMPi = jsActions.choices.FindIndex(x => x == jsActions.val);
            if (NavInfo.ContainsKey("Action")) NavInfo.Remove("Action");
            NavInfo.Add("Action", new NavInfoStru(jsActions.val, TMPi, "G", jsUseCP.val));
            RefleshNavBar();
            ActionHide();
            PropertyShow();
        }
        private void ActionSetLPMotions()
        {
            int TMPi = jsActions.choices.FindIndex(x => x == jsActions.val);
            if (NavInfo.ContainsKey("Action")) NavInfo.Remove("Action");
            NavInfo.Add("Action", new NavInfoStru(jsActions.val, TMPi, "P", jsUseCP.val));
            RefleshNavBar();
            ActionHide();
            PropertyShow();
        }
        private void ActionUIDLogic()
        {
            if (jsActions.choices.Count > 0 && jsActions.val == jsActions.choices[jsActions.choices.Count - 1]) { uiARemove.button.interactable = true; }
            else { uiARemove.button.interactable = false; }
            if (jsActions.val == "")
            {
                uiADuplicate.button.interactable = false;
                uiSetGPMotions.button.interactable = false;
                uiSetLPMotions.button.interactable = false;
                uiAComment.input.interactable = false;
                uiTargetGPs.input.interactable = false;
                uiTargetLgts.input.interactable = false;
                uiUseCP.toggle.interactable = false;
            }
            else
            {
                uiADuplicate.button.interactable = true;
                uiSetGPMotions.button.interactable = true;
                uiSetLPMotions.button.interactable = true;
                uiAComment.input.interactable = true;
                uiTargetGPs.input.interactable = true;
                uiTargetLgts.input.interactable = true;
                uiUseCP.toggle.interactable = true;
            }
            RefleshInfo();
        }

        /////////////////////////////////
        //Property UI Loghic Section
        /////////////////////////////////
        private void PropertyInit()
        {
            uiProperties = CreateScrollablePopup(jsProperties);
            jsProperties.setCallbackFunction = (val) => { PropertyUpdate(); };

            uiIsActive = CreateToggle(jsIsActive);
            jsIsActive.setCallbackFunction = (val) => { PropertySetVal("jsIsActive"); };

            uiLoopPlay = CreateToggle(jsLoopPlay);
            jsLoopPlay.setCallbackFunction = (val) => { PropertySetVal("jsLoopPlay"); };

            uiMotionType = CreateScrollablePopup(jsMotionType);
            jsMotionType.setCallbackFunction = (val) => { PropertySetVal("jsMotionType"); };

            uiRefValue = Utils.SetupTextInput(this, "Refer To", jsRefValue, false);
            jsRefValue.setCallbackFunction = (val) => { jsRefValue.val = StringFormat(val); PropertySetVal("jsRefValue"); };

            uiSetMNodes = CreateButton("Set Motion Nodes >>>");
            uiSetMNodes.button.onClick.AddListener(PropertySetNodes);
            uiSetMNodes.height = 100;
            uiSetMNodes.buttonColor = Color.green;

            uiWaitFor = CreateScrollablePopup(jsWaitFor);
            jsWaitFor.setCallbackFunction = (val) => { PropertySetVal("jsWaitFor"); };
            uiWaitForVal1 = CreateSlider(jsWaitForVal1);
            jsWaitForVal1.setCallbackFunction = (val) => { PropertySetVal("jsWaitForVal1"); };
            uiWaitForVal2 = CreateSlider(jsWaitForVal2);
            jsWaitForVal2.setCallbackFunction = (val) => { PropertySetVal("jsWaitForVal2"); };

            uiWarmUp = CreateScrollablePopup(jsWarmUp);
            jsWarmUp.setCallbackFunction = (val) => { PropertySetVal("jsWarmUp"); };
            uiWarmUpVal1 = CreateSlider(jsWarmUpVal1);
            jsWarmUpVal1.setCallbackFunction = (val) => { PropertySetVal("jsWarmUpVal1"); };
            uiWarmUpVal2 = CreateSlider(jsWarmUpVal2);
            jsWarmUpVal2.setCallbackFunction = (val) => { PropertySetVal("jsWarmUpVal2"); };

            uiCoolDown = CreateScrollablePopup(jsCoolDown);
            jsCoolDown.setCallbackFunction = (val) => { PropertySetVal("jsCoolDown"); };
            uiCoolDownVal1 = CreateSlider(jsCoolDownVal1);
            jsCoolDownVal1.setCallbackFunction = (val) => { PropertySetVal("jsCoolDownVal1"); };
            uiCoolDownVal2 = CreateSlider(jsCoolDownVal2);
            jsCoolDownVal2.setCallbackFunction = (val) => { PropertySetVal("jsCoolDownVal2"); };

            PropertyHide();
        }
        private void PropertyShow(string label = "", int index = -1)
        {
            UIShowAndHide(uiProperties, true);
            UIShowAndHide(uiIsActive, true);
            UIShowAndHide(uiLoopPlay, true);
            UIShowAndHide(uiMotionType, true);
            UIShowAndHide(uiRefValue, true);
            UIShowAndHide(uiWaitFor, true);
            UIShowAndHide(uiWaitForVal1, true);
            UIShowAndHide(uiWaitForVal2, true);
            UIShowAndHide(uiWarmUp, true);
            UIShowAndHide(uiWarmUpVal1, true);
            UIShowAndHide(uiWarmUpVal2, true);
            UIShowAndHide(uiCoolDown, true);
            UIShowAndHide(uiCoolDownVal1, true);
            UIShowAndHide(uiCoolDownVal2, true);
            UIShowAndHide(uiSetMNodes, true);
            PropertyGetVal(label, index);
        }
        private void PropertyHide()
        {
            UIShowAndHide(uiProperties, false);
            UIShowAndHide(uiIsActive, false);
            UIShowAndHide(uiLoopPlay, false);
            UIShowAndHide(uiMotionType, false);
            UIShowAndHide(uiRefValue, false);
            UIShowAndHide(uiWaitFor, false);
            UIShowAndHide(uiWaitForVal1, false);
            UIShowAndHide(uiWaitForVal2, false);
            UIShowAndHide(uiWarmUp, false);
            UIShowAndHide(uiWarmUpVal1, false);
            UIShowAndHide(uiWarmUpVal2, false);
            UIShowAndHide(uiCoolDown, false);
            UIShowAndHide(uiCoolDownVal1, false);
            UIShowAndHide(uiCoolDownVal2, false);
            UIShowAndHide(uiSetMNodes, false);
        }
        private void PropertyGetVal(string label = "", int index = -1)
        {
            float tempTime = modifiedTime;
            List<string> PropertyList = new List<string>();
            int AGi = NavInfo["AGroup"].index;
            int Aci = NavInfo["Action"].index;
            List<ConfPMotions> PMList;
            if (NavInfo["Action"].PType == "G") PMList = MLSConfObj.AGroups[AGi].Actions[Aci].GMPs;
            else PMList = MLSConfObj.AGroups[AGi].Actions[Aci].LMPs;

            if (NavInfo["Action"].PType == "G" && NavInfo["Action"].useCP) { foreach (var PM in GlobalConst.GPListUPC) { PropertyList.Add(PM); } }
            else { foreach (var PM in PMList) { PropertyList.Add(PM.name); } }

            jsProperties.choices = PropertyList;
            jsProperties.displayChoices = PropertyList;

            if (index < 0 || index >= jsProperties.choices.Count) index = 0;
            jsProperties.val = jsProperties.choices[index];

            jsIsActive.val = PMList[index].isActive;
            jsLoopPlay.val = PMList[index].loopPlay;
            jsMotionType.val = PMList[index].motionType;
            jsRefValue.val = PMList[index].refValue;
            jsWaitFor.val = PMList[index].waitFor.type;
            jsWaitForVal1.val = PMList[index].waitFor.val1;
            jsWaitForVal2.val = PMList[index].waitFor.val2;
            jsWarmUp.val = PMList[index].warmUp.type;
            jsWarmUpVal1.val = PMList[index].warmUp.val1;
            jsWarmUpVal2.val = PMList[index].warmUp.val2;
            jsCoolDown.val = PMList[index].coolDown.type;
            jsCoolDownVal1.val = PMList[index].coolDown.val1;
            jsCoolDownVal2.val = PMList[index].coolDown.val2;
            PropertyUIDLogic();
            modifiedTime = tempTime;
        }
        private void PropertyUpdate()
        {
            float tempTime = modifiedTime;
            int TMPi = jsProperties.choices.FindIndex(x => x == jsProperties.val);
            int AGi = NavInfo["AGroup"].index;
            int Aci = NavInfo["Action"].index;
            List<ConfPMotions> PMList;
            if (NavInfo["Action"].PType == "G") PMList = MLSConfObj.AGroups[AGi].Actions[Aci].GMPs;
            else PMList = MLSConfObj.AGroups[AGi].Actions[Aci].LMPs;
            if (TMPi >= 0)
            {
                jsIsActive.val = PMList[TMPi].isActive;
                jsLoopPlay.val = PMList[TMPi].loopPlay;
                jsMotionType.val = PMList[TMPi].motionType;
                jsRefValue.val = PMList[TMPi].refValue;
                jsWaitFor.val = PMList[TMPi].waitFor.type;
                jsWaitForVal1.val = PMList[TMPi].waitFor.val1;
                jsWaitForVal2.val = PMList[TMPi].waitFor.val2;
                jsWarmUp.val = PMList[TMPi].warmUp.type;
                jsWarmUpVal1.val = PMList[TMPi].warmUp.val1;
                jsWarmUpVal2.val = PMList[TMPi].warmUp.val2;
                jsCoolDown.val = PMList[TMPi].coolDown.type;
                jsCoolDownVal1.val = PMList[TMPi].coolDown.val1;
                jsCoolDownVal2.val = PMList[TMPi].coolDown.val2;
            }
            PropertyUIDLogic();
            modifiedTime = tempTime;
        }
        private void PropertySetVal(string valName = "All")
        {
            int TMPi = jsProperties.choices.FindIndex(x => x == jsProperties.val);
            int AGi = NavInfo["AGroup"].index;
            int Aci = NavInfo["Action"].index;
            List<ConfPMotions> PMList;
            if (NavInfo["Action"].PType == "G") PMList = MLSConfObj.AGroups[AGi].Actions[Aci].GMPs;
            else PMList = MLSConfObj.AGroups[AGi].Actions[Aci].LMPs;
            if (TMPi >= 0)
            {
                if (valName == "All" || valName == "jsIsActive") PMList[TMPi].isActive = jsIsActive.val;
                if (valName == "All" || valName == "jsLoopPlay") PMList[TMPi].loopPlay = jsLoopPlay.val;
                if (valName == "All" || valName == "jsMotionType") PMList[TMPi].motionType = jsMotionType.val;
                if (valName == "All" || valName == "jsRefValue") PMList[TMPi].refValue = jsRefValue.val;
                if (valName == "All" || valName == "jsWaitFor") PMList[TMPi].waitFor.type = jsWaitFor.val;
                if (valName == "All" || valName == "jsWaitForVal1") PMList[TMPi].waitFor.val1 = jsWaitForVal1.val;
                if (valName == "All" || valName == "jsWaitForVal2") PMList[TMPi].waitFor.val2 = jsWaitForVal2.val;
                if (valName == "All" || valName == "jsWarmUp") PMList[TMPi].warmUp.type = jsWarmUp.val;
                if (valName == "All" || valName == "jsWarmUpVal1") PMList[TMPi].warmUp.val1 = jsWarmUpVal1.val;
                if (valName == "All" || valName == "jsWarmUpVal2") PMList[TMPi].warmUp.val2 = jsWarmUpVal2.val;
                if (valName == "All" || valName == "jsCoolDown") PMList[TMPi].coolDown.type = jsCoolDown.val;
                if (valName == "All" || valName == "jsCoolDownVal1") PMList[TMPi].coolDown.val1 = jsCoolDownVal1.val;
                if (valName == "All" || valName == "jsCoolDownVal2") PMList[TMPi].coolDown.val2 = jsCoolDownVal2.val;

                if (jsProperties.val == "Color")
                {
                    if (valName == "All" || valName == "jsIsActive") { PMList[TMPi + 1].isActive = jsIsActive.val; PMList[TMPi + 2].isActive = jsIsActive.val; }
                    if (valName == "All" || valName == "jsLoopPlay") { PMList[TMPi + 1].loopPlay = jsLoopPlay.val; PMList[TMPi + 2].loopPlay = jsLoopPlay.val; }
                    if (valName == "All" || valName == "jsMotionType") { PMList[TMPi + 1].motionType = jsMotionType.val; PMList[TMPi + 2].motionType = jsMotionType.val; }
                    if (valName == "All" || valName == "jsRefValue") { PMList[TMPi + 1].refValue = jsRefValue.val; PMList[TMPi + 2].refValue = jsRefValue.val; }
                    if (valName == "All" || valName == "jsWaitFor") { PMList[TMPi + 1].waitFor.type = jsWaitFor.val; PMList[TMPi + 2].waitFor.type = jsWaitFor.val; }
                    if (valName == "All" || valName == "jsWaitForVal1") { PMList[TMPi + 1].waitFor.val1 = jsWaitForVal1.val; PMList[TMPi + 2].waitFor.val1 = jsWaitForVal1.val; }
                    if (valName == "All" || valName == "jsWaitForVal2") { PMList[TMPi + 1].waitFor.val2 = jsWaitForVal2.val; PMList[TMPi + 2].waitFor.val2 = jsWaitForVal2.val; }
                    if (valName == "All" || valName == "jsWarmUp") { PMList[TMPi + 1].warmUp.type = jsWarmUp.val; PMList[TMPi + 2].warmUp.type = jsWarmUp.val; }
                    if (valName == "All" || valName == "jsWarmUpVal1") { PMList[TMPi + 1].warmUp.val1 = jsWarmUpVal1.val; PMList[TMPi + 2].warmUp.val1 = jsWarmUpVal1.val; }
                    if (valName == "All" || valName == "jsWarmUpVal2") { PMList[TMPi + 1].warmUp.val2 = jsWarmUpVal2.val; PMList[TMPi + 2].warmUp.val2 = jsWarmUpVal2.val; }
                    if (valName == "All" || valName == "jsCoolDown") { PMList[TMPi + 1].coolDown.type = jsCoolDown.val; PMList[TMPi + 2].coolDown.type = jsCoolDown.val; }
                    if (valName == "All" || valName == "jsCoolDownVal1") { PMList[TMPi + 1].coolDown.val1 = jsCoolDownVal1.val; PMList[TMPi + 2].coolDown.val1 = jsCoolDownVal1.val; }
                    if (valName == "All" || valName == "jsCoolDownVal2") { PMList[TMPi + 1].coolDown.val2 = jsCoolDownVal2.val; PMList[TMPi + 2].coolDown.val2 = jsCoolDownVal2.val; }
                }
                modifiedTime = Time.time;
            }
            PropertyUIDLogic();
        }
        private void PropertySetNodes()
        {
            int TMPi = jsProperties.choices.FindIndex(x => x == jsProperties.val);
            if (NavInfo.ContainsKey("Property")) NavInfo.Remove("Property");
            NavInfo.Add("Property", new NavInfoStru(jsProperties.val, TMPi));
            RefleshNavBar();
            PropertyHide();
            MNodeShow();
        }
        private void PropertyUIDLogic()
        {
            if (jsIsActive.val)
            {
                uiLoopPlay.toggle.interactable = true;
                uiMotionType.popup.sliderControl.interactable = true;
                uiMotionType.popup.topButton.interactable = true;
                uiRefValue.input.interactable = true;
                uiWaitFor.popup.sliderControl.interactable = true;
                uiWaitFor.popup.topButton.interactable = true;
                uiWaitForVal1.slider.interactable = true;
                uiWaitForVal2.slider.interactable = true;
                uiWarmUp.popup.sliderControl.interactable = true;
                uiWarmUp.popup.topButton.interactable = true;
                uiWarmUpVal1.slider.interactable = true;
                uiWarmUpVal2.slider.interactable = true;
                uiCoolDown.popup.sliderControl.interactable = true;
                uiCoolDown.popup.topButton.interactable = true;
                uiCoolDownVal1.slider.interactable = true;
                uiCoolDownVal2.slider.interactable = true;
                uiSetMNodes.button.interactable = true;
            }
            else
            {
                uiLoopPlay.toggle.interactable = false;
                uiMotionType.popup.sliderControl.interactable = false;
                uiMotionType.popup.topButton.interactable = false;
                uiRefValue.input.interactable = false;
                uiWaitFor.popup.sliderControl.interactable = false;
                uiWaitFor.popup.topButton.interactable = false;
                uiWaitForVal1.slider.interactable = false;
                uiWaitForVal2.slider.interactable = false;
                uiWarmUp.popup.sliderControl.interactable = false;
                uiWarmUp.popup.topButton.interactable = false;
                uiWarmUpVal1.slider.interactable = false;
                uiWarmUpVal2.slider.interactable = false;
                uiCoolDown.popup.sliderControl.interactable = false;
                uiCoolDown.popup.topButton.interactable = false;
                uiCoolDownVal1.slider.interactable = false;
                uiCoolDownVal2.slider.interactable = false;
                uiSetMNodes.button.interactable = false;
            }
            if (jsMotionType.val == "Fellow") UIShowAndHide(uiRefValue, true);
            else UIShowAndHide(uiRefValue, false);
            if (jsWaitFor.val == "Fixed") UIShowAndHide(uiWaitForVal2, false);
            else
            {
                UIShowAndHide(uiWaitForVal2, true);
                if (jsWaitFor.val == "Random") jsWaitForVal2.min = 0.0F;
                else jsWaitForVal2.min = -100.0F;
            }
            if (jsWarmUp.val == "Fixed") UIShowAndHide(uiWarmUpVal2, false);
            else
            {
                UIShowAndHide(uiWarmUpVal2, true);
                if (jsWarmUp.val == "Random") jsWarmUpVal2.min = 0.0F;
                else jsWarmUpVal2.min = -100.0F;
            }
            if (jsCoolDown.val == "Fixed") UIShowAndHide(uiCoolDownVal2, false);
            else
            {
                UIShowAndHide(uiCoolDownVal2, true);
                if (jsCoolDown.val == "Random") jsCoolDownVal2.min = 0.0F;
                else jsCoolDownVal2.min = -100.0F;
            }
            RefleshInfo();
        }

        /////////////////////////////////
        //Node UI Loghic Section
        /////////////////////////////////
        private void MNodeInit()
        {
            uiMotionNodes = CreateScrollablePopup(jsMotionNodes);
            jsMotionNodes.setCallbackFunction = (val) => { MNodeUpdate(); };

            uiNodeAdd = CreateButton("Add Motion Node");
            uiNodeAdd.button.onClick.AddListener(MNodeAdd);

            uiNodeRemove = CreateButton("Remove Motion Node");
            uiNodeRemove.button.onClick.AddListener(MNodeRemove);
            uiNodeRemove.buttonColor = Color.red;
            uiNodeRemove.button.interactable = false;

            uiSpeedMode = CreateScrollablePopup(jsSpeedMode);
            jsSpeedMode.setCallbackFunction = (val) => { MNodeSetVal("jsSpeedMode"); };
            uiTime = CreateScrollablePopup(jsTime);
            jsTime.setCallbackFunction = (val) => { MNodeSetVal("jsTime"); };
            uiTime1 = CreateSlider(jsTime1);
            jsTime1.setCallbackFunction = (val) => { MNodeSetVal("jsTime1"); };
            uiTime2 = CreateSlider(jsTime2);
            jsTime2.setCallbackFunction = (val) => { MNodeSetVal("jsTime2"); };

            uiValue = CreateScrollablePopup(jsValue);
            jsValue.setCallbackFunction = (val) => { MNodeSetVal("jsValue"); };
            uiValue1 = CreateSlider(jsValue1);
            jsValue1.setCallbackFunction = (val) => { MNodeSetVal("jsValue1"); };
            uiValue2 = CreateSlider(jsValue2);
            jsValue2.setCallbackFunction = (val) => { MNodeSetVal("jsValue2"); };

            uiColor1 = CreateColorPicker(jsColor1);
            jsColor1.setCallbackFunction = (h, s, v) => { MNodeSetVal("jsColor1"); };
            uiColor2 = CreateColorPicker(jsColor2);
            jsColor2.setCallbackFunction = (h, s, v) => { MNodeSetVal("jsColor2"); };

            uiSetTrigger = CreateToggle(jsSetTrigger);
            jsSetTrigger.setCallbackFunction = (val) => { MNodeSetVal("jsSetTrigger"); };

            uiIsRepeatable = CreateToggle(jsIsRepeatable);
            jsIsRepeatable.setCallbackFunction = (val) => { MNodeSetVal("jsIsRepeatable"); };

            uiTraceAtom = Utils.SetupTextInput(this, "Trace Atom", jsTraceAtom, false);
            jsTraceAtom.setCallbackFunction = (val) => { jsTraceAtom.val = StringFormat(val); MNodeSetVal("jsTraceAtom"); };

            uiThreshold = CreateSlider(jsThreshold);
            jsThreshold.setCallbackFunction = (val) => { jsThreshold.val = Mathf.Round(val); MNodeSetVal("jsThreshold"); };

            uiIsInternal = CreateToggle(jsIsInternal);
            jsIsInternal.setCallbackFunction = (val) => { MNodeSetVal("jsIsInternal"); };

            uiDoAction = Utils.SetupTextInput(this, "Action To Do", jsDoAction, false);
            jsDoAction.setCallbackFunction = (val) => { jsDoAction.val = StringFormat(val); MNodeSetVal("jsDoAction"); };

            MNodeHide();
        }
        private void MNodeShow(string label = "", int index = -1)
        {
            jsMotionNodes.choices.Clear();
            jsMotionNodes.displayChoices.Clear();
            jsMotionNodes.val = "";
            UIShowAndHide(uiMotionNodes, true);
            UIShowAndHide(uiNodeAdd, true);
            UIShowAndHide(uiNodeRemove, true);
            UIShowAndHide(uiSpeedMode, true);
            UIShowAndHide(uiTime, true);
            UIShowAndHide(uiTime1, true);
            UIShowAndHide(uiTime2, true);
            UIShowAndHide(uiValue, true);
            if (NavInfo["Property"].label == "Color")
            {
                UIShowAndHide(uiColor1, true);
                UIShowAndHide(uiColor2, true);
            }
            else
            {
                UIShowAndHide(uiValue1, true);
                jsValue1.max = GlobalConst.max[NavInfo["Property"].label];
                jsValue1.defaultVal = GlobalConst.def[NavInfo["Property"].label];
                jsValue1.min = GlobalConst.min[NavInfo["Property"].label];
                UIShowAndHide(uiValue2, true);
                jsValue2.max = GlobalConst.max[NavInfo["Property"].label];
                jsValue2.defaultVal = GlobalConst.def[NavInfo["Property"].label];
                jsValue2.min = GlobalConst.min[NavInfo["Property"].label];
            }
            UIShowAndHide(uiSetTrigger, true);
            UIShowAndHide(uiIsRepeatable, true);
            UIShowAndHide(uiTraceAtom, true);
            UIShowAndHide(uiThreshold, true);
            UIShowAndHide(uiIsInternal, true);
            UIShowAndHide(uiDoAction, true);
            MNodeGetVal(label, index);
        }
        private void MNodeHide()
        {
            UIShowAndHide(uiMotionNodes, false);
            UIShowAndHide(uiNodeAdd, false);
            UIShowAndHide(uiNodeRemove, false);
            UIShowAndHide(uiSpeedMode, false);
            UIShowAndHide(uiTime, false);
            UIShowAndHide(uiTime1, false);
            UIShowAndHide(uiTime2, false);
            UIShowAndHide(uiValue, false);
            UIShowAndHide(uiValue1, false);
            UIShowAndHide(uiValue2, false);
            UIShowAndHide(uiColor1, false);
            UIShowAndHide(uiColor2, false);
            UIShowAndHide(uiSetTrigger, false);
            UIShowAndHide(uiIsRepeatable, false);
            UIShowAndHide(uiTraceAtom, false);
            UIShowAndHide(uiThreshold, false);
            UIShowAndHide(uiIsInternal, false);
            UIShowAndHide(uiDoAction, false);
        }
        private void MNodeGetVal(string label = "", int index = -1, bool newNode = false)
        {
            float tempTime = modifiedTime;
            List<string> MNodeList = new List<string>();
            int AGi = NavInfo["AGroup"].index;
            int Aci = NavInfo["Action"].index;
            int Pri = NavInfo["Property"].index;

            List<ConfPMotions> PMList;
            if (NavInfo["Action"].PType == "G") PMList = MLSConfObj.AGroups[AGi].Actions[Aci].GMPs;
            else PMList = MLSConfObj.AGroups[AGi].Actions[Aci].LMPs;
            foreach (var MN in PMList[Pri].MNodes) { MNodeList.Add(MN.name); }
            jsMotionNodes.choices = MNodeList;
            jsMotionNodes.displayChoices = MNodeList;

            if (jsMotionNodes.choices.Count > 0)
            {
                if (index < 0 || index >= jsMotionNodes.choices.Count) index = 0;
                jsMotionNodes.val = jsMotionNodes.choices[index];
            }
            else jsMotionNodes.val = "";

            if (index >= 0 && !newNode)
            {
                jsSpeedMode.val = PMList[Pri].MNodes[index].speedMode;
                jsTime.val = PMList[Pri].MNodes[index].time.type;
                jsTime1.val = PMList[Pri].MNodes[index].time.val1;
                jsTime2.val = PMList[Pri].MNodes[index].time.val2;
                jsValue.val = PMList[Pri].MNodes[index].value.type;
                if (NavInfo["Property"].label == "Color")
                {
                    float H1 = PMList[Pri].MNodes[index].value.val1;
                    float S1 = PMList[Pri + 1].MNodes[index].value.val1;
                    float V1 = PMList[Pri + 2].MNodes[index].value.val1;
                    jsColor1.SetVal(H1, S1, V1);

                    float H2 = PMList[Pri].MNodes[index].value.val2;
                    float S2 = PMList[Pri + 1].MNodes[index].value.val2;
                    float V2 = PMList[Pri + 2].MNodes[index].value.val2;
                    jsColor2.SetVal(H2, S2, V2);
                }
                else
                {
                    jsValue1.val = PMList[Pri].MNodes[index].value.val1;
                    jsValue2.val = PMList[Pri].MNodes[index].value.val2;
                }
                jsSetTrigger.val = PMList[Pri].MNodes[index].setTrigger;
                jsIsRepeatable.val = PMList[Pri].MNodes[index].isRepeatable;
                jsTraceAtom.val = PMList[Pri].MNodes[index].traceAtom;
                jsThreshold.val = PMList[Pri].MNodes[index].threshold;
                jsIsInternal.val = PMList[Pri].MNodes[index].isInternal;
                jsDoAction.val = PMList[Pri].MNodes[index].doAction;
            }
            else
            {
                jsSpeedMode.val = "Normal";
                jsTime.val = "Fixed";
                jsTime1.val = 0.0F;
                jsTime2.val = 0.0F;
                jsValue.val = "Fixed";
                if (NavInfo["Property"].label == "Color")
                {
                    float H1 = GlobalConst.def["ColorH"];
                    float S1 = GlobalConst.def["ColorS"];
                    float V1 = GlobalConst.def["ColorV"];
                    jsColor1.SetVal(H1, S1, V1);

                    float H2 = GlobalConst.def["ColorH"];
                    float S2 = GlobalConst.def["ColorS"];
                    float V2 = GlobalConst.def["ColorV"];
                    jsColor2.SetVal(H2, S2, V2);
                }
                else
                {
                    jsValue1.val = GlobalConst.def[NavInfo["Property"].label];
                    jsValue2.val = GlobalConst.def[NavInfo["Property"].label];
                }
                jsSetTrigger.val = false;
                jsIsRepeatable.val = false;
                jsTraceAtom.val = "";
                jsThreshold.val = 1.0f;
                jsIsInternal.val = true;
                jsDoAction.val = "";
            }

            MNodeUIDLogic();
            modifiedTime = tempTime;
        }
        private void MNodeUpdate()
        {
            float tempTime = modifiedTime;
            int TMPi = jsMotionNodes.choices.FindIndex(x => x == jsMotionNodes.val);
            int AGi = NavInfo["AGroup"].index;
            int Aci = NavInfo["Action"].index;
            int Pri = NavInfo["Property"].index;
            List<ConfPMotions> PMList;
            if (NavInfo["Action"].PType == "G") PMList = MLSConfObj.AGroups[AGi].Actions[Aci].GMPs;
            else PMList = MLSConfObj.AGroups[AGi].Actions[Aci].LMPs;
            if (TMPi >= 0 && jsMotionNodes.val != "")
            {
                jsSpeedMode.val = PMList[Pri].MNodes[TMPi].speedMode;
                jsTime.val = PMList[Pri].MNodes[TMPi].time.type;
                jsTime1.val = PMList[Pri].MNodes[TMPi].time.val1;
                jsTime2.val = PMList[Pri].MNodes[TMPi].time.val2;
                jsValue.val = PMList[Pri].MNodes[TMPi].value.type;
                if (NavInfo["Property"].label == "Color")
                {
                    Single H1 = PMList[Pri].MNodes[TMPi].value.val1;
                    Single S1 = PMList[Pri + 1].MNodes[TMPi].value.val1;
                    Single V1 = PMList[Pri + 2].MNodes[TMPi].value.val1;
                    jsColor1.SetVal(H1, S1, V1);

                    Single H2 = PMList[Pri].MNodes[TMPi].value.val2;
                    Single S2 = PMList[Pri + 1].MNodes[TMPi].value.val2;
                    Single V2 = PMList[Pri + 2].MNodes[TMPi].value.val2;
                    jsColor2.SetVal(H2, S2, V2);
                }
                else
                {
                    jsValue1.val = PMList[Pri].MNodes[TMPi].value.val1;
                    jsValue2.val = PMList[Pri].MNodes[TMPi].value.val2;
                }
                jsSetTrigger.val = PMList[Pri].MNodes[TMPi].setTrigger;
                jsIsRepeatable.val = PMList[Pri].MNodes[TMPi].isRepeatable;
                jsTraceAtom.val = PMList[Pri].MNodes[TMPi].traceAtom;
                jsThreshold.val = PMList[Pri].MNodes[TMPi].threshold;
                jsIsInternal.val = PMList[Pri].MNodes[TMPi].isInternal;
                jsDoAction.val = PMList[Pri].MNodes[TMPi].doAction;
            }
            MNodeUIDLogic();
            modifiedTime = tempTime;
        }
        private void MNodeSetVal(string valName = "All")
        {
            int TMPi = jsMotionNodes.choices.FindIndex(x => x == jsMotionNodes.val);
            int AGi = NavInfo["AGroup"].index;
            int Aci = NavInfo["Action"].index;
            int Pri = NavInfo["Property"].index;
            List<ConfPMotions> PMList;
            if (NavInfo["Action"].PType == "G") PMList = MLSConfObj.AGroups[AGi].Actions[Aci].GMPs;
            else PMList = MLSConfObj.AGroups[AGi].Actions[Aci].LMPs;
            if (TMPi >= 0)
            {
                if (valName == "All" || valName == "jsSpeedMode") PMList[Pri].MNodes[TMPi].speedMode = jsSpeedMode.val;
                if (valName == "All" || valName == "jsTime") PMList[Pri].MNodes[TMPi].time.type = jsTime.val;
                if (valName == "All" || valName == "jsTime1") PMList[Pri].MNodes[TMPi].time.val1 = jsTime1.val;
                if (valName == "All" || valName == "jsTime2") PMList[Pri].MNodes[TMPi].time.val2 = jsTime2.val;
                if (valName == "All" || valName == "jsValue") PMList[Pri].MNodes[TMPi].value.type = jsValue.val;

                if (NavInfo["Property"].label == "Color")
                {
                    if (valName == "All" || valName == "jsSpeedMode")
                    {
                        PMList[Pri + 1].MNodes[TMPi].speedMode = jsSpeedMode.val;
                        PMList[Pri + 2].MNodes[TMPi].speedMode = jsSpeedMode.val;
                    }
                    if (valName == "All" || valName == "jsTime")
                    {
                        PMList[Pri + 1].MNodes[TMPi].time.type = jsTime.val;
                        PMList[Pri + 2].MNodes[TMPi].time.type = jsTime.val;
                    }
                    if (valName == "All" || valName == "jsTime1")
                    {
                        PMList[Pri + 1].MNodes[TMPi].time.val1 = jsTime1.val;
                        PMList[Pri + 2].MNodes[TMPi].time.val1 = jsTime1.val;
                    }
                    if (valName == "All" || valName == "jsTime2")
                    {
                        PMList[Pri + 1].MNodes[TMPi].time.val2 = jsTime2.val;
                        PMList[Pri + 2].MNodes[TMPi].time.val2 = jsTime2.val;
                    }
                    if (valName == "All" || valName == "jsValue")
                    {
                        PMList[Pri + 1].MNodes[TMPi].value.type = jsValue.val;
                        PMList[Pri + 2].MNodes[TMPi].value.type = jsValue.val;
                    }

                    if (valName == "All" || valName == "jsColor1")
                    {
                        PMList[Pri].MNodes[TMPi].value.val1 = jsColor1.val.H;
                        PMList[Pri + 1].MNodes[TMPi].value.val1 = jsColor1.val.S;
                        PMList[Pri + 2].MNodes[TMPi].value.val1 = jsColor1.val.V;
                    }

                    if (valName == "All" || valName == "jsColor2")
                    {
                        PMList[Pri].MNodes[TMPi].value.val2 = jsColor2.val.H;
                        PMList[Pri + 1].MNodes[TMPi].value.val2 = jsColor2.val.S;
                        PMList[Pri + 2].MNodes[TMPi].value.val2 = jsColor2.val.V;
                    }
                }
                else
                {
                    if (valName == "All" || valName == "jsValue1") PMList[Pri].MNodes[TMPi].value.val1 = jsValue1.val;
                    if (valName == "All" || valName == "jsValue2") PMList[Pri].MNodes[TMPi].value.val2 = jsValue2.val;
                }
                if (valName == "All" || valName == "jsSetTrigger") PMList[Pri].MNodes[TMPi].setTrigger = jsSetTrigger.val;
                if (valName == "All" || valName == "jsIsRepeatable") PMList[Pri].MNodes[TMPi].isRepeatable = jsIsRepeatable.val;
                if (valName == "All" || valName == "jsTraceAtom") PMList[Pri].MNodes[TMPi].traceAtom = jsTraceAtom.val;
                if (valName == "All" || valName == "jsThreshold") PMList[Pri].MNodes[TMPi].threshold = (int)(jsThreshold.val + 0.1);
                if (valName == "All" || valName == "jsIsInternal") PMList[Pri].MNodes[TMPi].isInternal = jsIsInternal.val;
                if (valName == "All" || valName == "jsDoAction") PMList[Pri].MNodes[TMPi].doAction = jsDoAction.val;
                modifiedTime = Time.time;
            }
            MNodeUIDLogic();
        }
        private void MNodeAdd()
        {
            int AGi = NavInfo["AGroup"].index;
            int Aci = NavInfo["Action"].index;
            int Pri = NavInfo["Property"].index;

            List<ConfPMotions> PMList;
            if (NavInfo["Action"].PType == "G") PMList = MLSConfObj.AGroups[AGi].Actions[Aci].GMPs;
            else PMList = MLSConfObj.AGroups[AGi].Actions[Aci].LMPs;

            NavInfoStru MNodeInfo = PMList[Pri].AddMNode();
            if (NavInfo["Property"].label == "Color") { PMList[Pri + 1].AddMNode(); PMList[Pri + 2].AddMNode(); }
            MNodeGetVal(MNodeInfo.label, MNodeInfo.index, true);
            modifiedTime = Time.time;
        }
        private void MNodeRemove()
        {
            int AGi = NavInfo["AGroup"].index;
            int Aci = NavInfo["Action"].index;
            int Pri = NavInfo["Property"].index;

            List<ConfPMotions> PMList;
            if (NavInfo["Action"].PType == "G") PMList = MLSConfObj.AGroups[AGi].Actions[Aci].GMPs;
            else PMList = MLSConfObj.AGroups[AGi].Actions[Aci].LMPs;

            NavInfoStru MNodeInfo = PMList[Pri].RemoveMNode();
            if (NavInfo["Property"].label == "Color") { PMList[Pri + 1].RemoveMNode(); PMList[Pri + 2].RemoveMNode(); }
            MNodeGetVal(MNodeInfo.label, MNodeInfo.index);
            modifiedTime = Time.time;
        }
        private void MNodeUIDLogic()
        {
            if (jsMotionNodes.choices.Count > 0 && jsMotionNodes.val == jsMotionNodes.choices[jsMotionNodes.choices.Count - 1]) { uiNodeRemove.button.interactable = true; }
            else { uiNodeRemove.button.interactable = false; }

            if (jsMotionNodes.choices.Count > 0)
            {
                uiSpeedMode.popup.sliderControl.interactable = true;
                uiSpeedMode.popup.topButton.interactable = true;
                uiTime.popup.sliderControl.interactable = true;
                uiTime.popup.topButton.interactable = true;
                uiTime1.slider.interactable = true;
                uiTime2.slider.interactable = true;
                uiValue.popup.sliderControl.interactable = true;
                uiValue.popup.topButton.interactable = true;
                uiValue1.slider.interactable = true;
                uiValue2.slider.interactable = true;
                uiSetTrigger.toggle.interactable = true;
                uiIsRepeatable.toggle.interactable = true;
                uiTraceAtom.input.interactable = true;
                uiThreshold.slider.interactable = true;
                uiIsInternal.toggle.interactable = true;
                uiDoAction.input.interactable = true;
            }
            else
            {
                uiSpeedMode.popup.sliderControl.interactable = false;
                uiSpeedMode.popup.topButton.interactable = false;
                uiTime.popup.sliderControl.interactable = false;
                uiTime.popup.topButton.interactable = false;
                uiTime1.slider.interactable = false;
                uiTime2.slider.interactable = false;
                uiValue.popup.sliderControl.interactable = false;
                uiValue.popup.topButton.interactable = false;
                uiValue1.slider.interactable = false;
                uiValue2.slider.interactable = false;
                uiSetTrigger.toggle.interactable = false;
                uiIsRepeatable.toggle.interactable = false;
                uiTraceAtom.input.interactable = false;
                uiThreshold.slider.interactable = false;
                uiIsInternal.toggle.interactable = false;
                uiDoAction.input.interactable = false;
            }
            if (jsTime.val == "Fixed") UIShowAndHide(uiTime2, false);
            else
            {
                UIShowAndHide(uiTime2, true);
                if (jsTime.val == "Random") jsTime2.min = 0.0F;
                else jsTime2.min = -100.0F;
            }
            if (NavInfo["Property"].label == "Color")
            {
                if (jsValue.val == "Fixed") UIShowAndHide(uiColor2, false);
                else UIShowAndHide(uiColor2, true);
            }
            else
            {
                if (jsValue.val == "Fixed") UIShowAndHide(uiValue2, false);
                else
                {
                    UIShowAndHide(uiValue2, true);
                    if (jsValue.val == "Random") jsValue2.min = GlobalConst.min[NavInfo["Property"].label];
                    else jsValue2.min = -GlobalConst.max[NavInfo["Property"].label];
                }
            }
            if (jsSetTrigger.val)
            {
                UIShowAndHide(uiIsRepeatable, true);
                UIShowAndHide(uiTraceAtom, true);
                UIShowAndHide(uiThreshold, true);
                UIShowAndHide(uiIsInternal, true);
                UIShowAndHide(uiDoAction, true);
            }
            else
            {
                UIShowAndHide(uiIsRepeatable, false);
                UIShowAndHide(uiTraceAtom, false);
                UIShowAndHide(uiThreshold, false);
                UIShowAndHide(uiIsInternal, false);
                UIShowAndHide(uiDoAction, false);
            }

            int AGi = NavInfo["AGroup"].index;
            int Aci = NavInfo["Action"].index;
            int Pri = NavInfo["Property"].index;
            List<ConfPMotions> PMList;
            if (NavInfo["Action"].PType == "G") PMList = MLSConfObj.AGroups[AGi].Actions[Aci].GMPs;
            else PMList = MLSConfObj.AGroups[AGi].Actions[Aci].LMPs;

            if (PMList[Pri].motionType == "Process") UIShowAndHide(uiSpeedMode, true);
            else  UIShowAndHide(uiSpeedMode, false);

            RefleshInfo();
        }

        /////////////////////////////////
        //Public Method Section
        /////////////////////////////////
        private void UIShowAndHide(UIDynamic UIObj, bool show)
        {
            if (show)
            {
                UIObj.GetComponent<LayoutElement>().transform.localScale = new Vector3(1, 1, 1);
                UIObj.GetComponent<LayoutElement>().ignoreLayout = false;
            }
            else
            {
                UIObj.GetComponent<LayoutElement>().transform.localScale = new Vector3(0, 0, 0);
                UIObj.GetComponent<LayoutElement>().ignoreLayout = true;
            }
        }
        private string StringFormat(string str)
        {
            str = str.Replace("<", "");
            str = str.Replace(">", "");
            str = str.Replace(",", "");
            str = str.Replace(".", "");
            str = str.Replace("\\", "");
            return str;
        }
        private string GetDescription()
        {
            string resStr;
            if (NavInfo.ContainsKey("Property")) resStr = MLSDesc.MNode;
            else if (NavInfo.ContainsKey("Action")) resStr = MLSDesc.Property;
            else if (NavInfo.ContainsKey("AGroup")) resStr = MLSDesc.Action;
            else resStr = MLSDesc.AGroup;
            return resStr;
        }
        private string GetConfStructure()
        {
            string wrapStr = "<size=10>\n\n</size>";
            string padding = "        ";
            string startMark = ": ";
            string resStr = $"<size=33><B>Configuration Structure:</B></size>{wrapStr}";
            foreach (var AGroup in MLSConfObj.AGroups)
            {
                string tempStr;
                bool curAGroup = false;
                string commentStr = AGroup.comment.Length > 0 ? " :: " + AGroup.comment : "";
                if ((NavInfo.ContainsKey("AGroup") && NavInfo["AGroup"].label == AGroup.name) || jsAGroups.val == AGroup.name)
                {
                    tempStr = $"{startMark}<B>{AGroup.name}</B>{commentStr}{wrapStr}";
                    curAGroup = true;
                }
                else
                {
                    tempStr = $"{startMark}{AGroup.name}{commentStr}{wrapStr}";
                    curAGroup = false;
                }
                resStr += tempStr;
                foreach (var Action in AGroup.Actions)
                {
                    bool curAction = false;
                    commentStr = Action.comment.Length > 0 ? " :: " + Action.comment : "";
                    if (curAGroup && ((NavInfo.ContainsKey("Action") && NavInfo["Action"].label == Action.name) || (jsActions.val == Action.name && NavInfo.ContainsKey("AGroup"))))
                    {
                        tempStr = $"{startMark}{padding}<B>{Action.name}</B>{commentStr}{wrapStr}";
                        curAction = true;
                    }
                    else
                    {
                        tempStr = $"{startMark}{padding}{Action.name}{commentStr}{wrapStr}";
                        curAction = false;
                    }
                    resStr += tempStr;

                    List<ConfPMotions> tempList = new List<ConfPMotions>();
                    tempList.AddRange(Action.GMPs);
                    tempList.AddRange(Action.LMPs);
                    foreach (var Property in tempList)
                    {
                        if (!Property.isActive) continue;
                        bool curProperty = false;
                        string PName = Property.name;
                        if (PName == "ColorH" && Action.useCP) PName = "Color";
                        else if ((PName == "ColorS" || PName == "ColorV") && Action.useCP) continue;

                        if (curAction && ((NavInfo.ContainsKey("Property") && NavInfo["Property"].label == PName) || (jsProperties.val == PName && NavInfo.ContainsKey("Action"))))
                        {
                            tempStr = $"{startMark}{padding}{padding}<B>{PName}</B>{wrapStr}";
                            curProperty = true;
                        }
                        else
                        {
                            tempStr = $"{startMark}{padding}{padding}{PName}{wrapStr}";
                            curProperty = false;
                        }
                        resStr += tempStr;
                        foreach (var MNode in Property.MNodes)
                        {
                            string ifTrigger = MNode.setTrigger ? "<Trigger>" : "";
                            if (curProperty && jsMotionNodes.val == MNode.name && NavInfo.ContainsKey("Property")) tempStr = $"{startMark}{padding}{padding}{padding}<B>{MNode.name}</B> {ifTrigger}{wrapStr}";
                            else tempStr = $"{startMark}{padding}{padding}{padding}{MNode.name} {ifTrigger}{wrapStr}";
                            resStr += tempStr;
                        }
                    }
                }
            }
            return resStr;
        }

        private bool loading = true;
        private float autoSaveTimer = Time.time + 5.0F;
        private float prepareTimer = 0.0F;
        private int prepareStep = 0;
        private List<string> emptyGroups = new List<string>();
        private List<string> allGroups = new List<string>();
        public void FixedUpdate()
        {
            if (!SuperController.singleton.isLoading)
            {
                if (loading)
                {
                    try { LoadMLSConf(); }
                    catch { SuperController.LogError("Faild to load MLS Config"); }
                    loading = false;
                }
                if (autoSaveTimer < Time.time)
                {
                    autoSaveTimer = Time.time + 5.0F;
                    try { SaveMLSConf(); }
                    catch { SuperController.LogError("Faild to save MLS Config"); }
                    foreach (var KVP in MLSMotionObj.mlsGroupDict) { KVP.Value.MLSLightGroup.CallAction("Save HPVL Settings"); }
                }

                if (prepareStep == 0)
                {
                    MLSMotionObj.RefleshMLSAtoms();
                    foreach (var KVP in MLSMotionObj.mlsGroupDict)
                    {
                        if (KVP.Value.mlsLightList.Count == 0) { emptyGroups.Add(KVP.Key); }
                        allGroups.Add(KVP.Key);
                    }
                    prepareStep++;
                    RefleshPlugins();
                }
                if (prepareStep == 1 && prepareTimer < Time.time)
                {
                    if (emptyGroups.Count > 0)
                    {
                        MLSMotionObj.mlsGroupDict[emptyGroups[0]].MLSLightGroup.CallAction("Build Lights");
                        emptyGroups.RemoveAt(0);
                    }
                    else prepareStep++;
                    prepareTimer = Time.time + 0.05F;
                }
                if (prepareStep == 2 && prepareTimer < Time.time)
                {
                    if (allGroups.Count > 0)
                    {
                        MLSMotionObj.mlsGroupDict[allGroups[0]].HPVL.CallAction("Initialize HPVL");
                        allGroups.RemoveAt(0);
                    }
                    else prepareStep++;
                    prepareTimer = Time.time + 0.05F;
                }
                if (prepareStep == 3 && prepareTimer < Time.time)
                {
                    foreach (var KVP in MLSMotionObj.mlsGroupDict) { KVP.Value.MLSLightGroup.CallAction("Restore HPVL Settings"); }
                    MLSMotionObj.RefleshMLSAtoms();
                    prepareStep++;
                }

                if (prepareStep == 4)
                {
                    MLSMotionObj.PerformMotions();
                }
            }
        }
        private void RefleshPlugins()
        {
            List<string> storableIDs = containingAtom.GetStorableIDs();
            foreach (var thisID in storableIDs)
            {
                if (thisID.Contains("MLSCC")) MLSMotionObj.theMLSCC = containingAtom.GetStorableByID(thisID);
                else if (thisID.Contains("VUML")) MLSMotionObj.theVUML = containingAtom.GetStorableByID(thisID);
                else if (thisID.Contains("SelectChoice")) MLSMotionObj.theSelectChoice = containingAtom.GetStorableByID(thisID);
            }
        }
    }

    public static class GlobalConst
    {
        public static List<string> GPList = new List<string> { "Angle", "Intensity", "Radius", "FadeEnd", "ColorH", "ColorS", "ColorV" };
        public static List<string> GPListUPC = new List<string> { "Angle", "Intensity", "Radius", "FadeEnd", "Color" };
        public static List<string> LPList = new List<string> { "Pitch", "Yaw", "YawAlt", "Switch", "Lightness" };
        public static List<string> MotionTypeList = new List<string> { "Process", "Event", "Fellow" };
        public static List<string> ValueTypeList = new List<string> { "Fixed", "Random", "Incremental" };
        public static List<string> SpeedModeList = new List<string> { "Normal", "Accelerate", "Decelerate" };
        public static string NavBass = "                                                                >> ";
        public static string NavSeparator = " > ";
        public static List<string> NavInfoNames = new List<string> { "AGroup", "Action", "Property", "Node" };
        public static Dictionary<string, float> max = new Dictionary<string, float>();
        public static Dictionary<string, float> def = new Dictionary<string, float>();
        public static Dictionary<string, float> min = new Dictionary<string, float>();

        public static void InitDic()
        {
            max.Add("Angle", 90.0f);
            max.Add("Intensity", 5.0f);
            max.Add("Radius", 1.0f);
            max.Add("FadeEnd", 50.0f);
            max.Add("ColorH", 1.0f);
            max.Add("ColorS", 1.0f);
            max.Add("ColorV", 1.0f);
            max.Add("Pitch", 180.0f);
            max.Add("Yaw", 360.0f);
            max.Add("YawAlt", 90.0f);
            max.Add("Switch", 1.0f);
            max.Add("Lightness", 1.0f);

            def.Add("Angle", 15.0f);
            def.Add("Intensity", 1.0f);
            def.Add("Radius", 0.05f);
            def.Add("FadeEnd", 15.0f);
            def.Add("ColorH", 0.0f);
            def.Add("ColorS", 0.0f);
            def.Add("ColorV", 1.0f);
            def.Add("Pitch", 90.0f);
            def.Add("Yaw", 0.0f);
            def.Add("YawAlt", 0.0f);
            def.Add("Switch", 0.0f);
            def.Add("Lightness", 1.0f);

            min.Add("Angle", 0.0f);
            min.Add("Intensity", 0.0f);
            min.Add("Radius", 0.0f);
            min.Add("FadeEnd", 0.0f);
            min.Add("ColorH", 0.0f);
            min.Add("ColorS", 0.0f);
            min.Add("ColorV", 0.0f);
            min.Add("Pitch", 0.0f);
            min.Add("Yaw", -360.0f);
            min.Add("YawAlt", -90.0f);
            min.Add("Switch", 0.0f);
            min.Add("Lightness", 0.0f);
        }
    }

    public struct NavInfoStru
    {
        public string label;
        public int index;
        public string PType;
        public bool useCP;
        public NavInfoStru(string a, int b, string c = "", bool d = true)
        {
            label = a;
            index = b;
            PType = c;
            useCP = d;
        }
    }
}