namespace FrogFrog
{
    public static class MLSDesc {
        public static string AGroup = 
@"<size=33><B>Description: AGroup</B></size>

AGroup (Action Group) is usually the smallest practical execution unit in MLS. This is because in actual lighting design, multiple Actions within an A Group need to cooperate with each other to achieve the desired effect, such as part of the lights flashing while another part changes color.

It is recommended that you add comments to each created A Group so that you can quickly identify its purpose.";
        public static string Action = 
@"<size=33><B>Description: Action</B></size>

An Action can control multiple properties of multiple light groups and multiple lights, but the change patterns of the same property of these light groups and lights must be the same. That's why we need the concept of A Group, allowing us to achieve the desired effect through the cooperation of multiple Actions.

When creating an Action, you first need to specify the light groups and lights you want to operate on, and determine the order of these actions (natural order, reverse order, or in the order of configured inputs).

You can also choose whether to tick <B>'Use Color Picker'</B> to operate on color as a whole or split it into three independent properties: Hue, Saturation, and Value.

I also recommend adding comments to each Action to quickly identify its purpose.";
        public static string Property = 
@"<size=33><B>Description: Property</B></size>

The properties of Angle, Intensity, Radius, FadeEnd, and Color are applicable to light groups, while the properties of Pitch, Yaw, YawAlt, Switch, and Lightness are applicable to individual lights. Each property can be controlled independently.

When setting a property, it is important to specify its Motion Type, which can be <B>'Process'</B> (continuous change), <B>'Event'</B> (discontinuous change), or <B>'Fellow'</B> (change following an external variable). If <B>'Fellow'</B> is chosen, the name of the referenced external variable must be specified. This should be a VUML plugin variable loaded on the same atom as MLSCC, with a floating-point value between 0 and 1.

You can choose whether the property animation loops, and specify its waiting time, warm-up time, and cooling time. The looping of the property animation will include the warm-up time and cooling time, but not the waiting time.

There are three modes for specifying floating-point parameters: <B>'Fixed'</B> (where the Alt value does not affect), <B>'Random'</B> (where a result is randomly selected between the value and Alt value each time it is used), and <B>'Incremental'</B> (where the value is the starting point, and the Alt value is the step size, incrementing sequentially based on the order of atom operations).

The specific changes in property values are specified through <B>'Motion Nodes'</B>.";
        public static string MNode = 
@"<size=33><B>Description: MNode</B></size>

Each MNode (Motion Node) declares the value that a property should reach and the time it should reach that value. The property value changes continuously or discontinuously between multiple MNodes, thus creating an animation.

If the <B>'Motion Type'</B> of a property is set to <B>'Fellow'</B>, two Motion Nodes (MNode0 and MNode1) must be set. The property value will change between MNode0 and MNode1 based on the changes in the external variable (additional MNode settings will not be effective).

We can set a trigger for a Motion Node, specifying a Trace Atom (the name of a light group or a light atom applicable to the current Motion Node). When the number of times this atom achieves the current Motion Node reaches a threshold, the specified action can be triggered. This action can be internal, i.e., an already configured AGroup, or external, i.e., an choice from the SelectChoice plugin loaded on the same atom as MLSCC. The trigger can be activated once or repeatedly.";
    }
}
